﻿Imports System.Runtime.CompilerServices
Imports System.Diagnostics

Namespace System

   Public Class NotifyEventArgs
      Public Shared Function Create(Of T)(value As T) As NotifyEventArgs(Of T)
         Return New NotifyEventArgs(Of T)(value)
      End Function
      Public Shared Function Create(ParamArray values As Object()) As NotifyEventArgs(Of String)
         Return New NotifyEventArgs(Of String)(String.Concat(values))
      End Function
   End Class
   Public Class NotifyEventArgs(Of T) : Inherits EventArgs
      Public ReadOnly Value As T
      Public Sub New(Value As T)
         MyBase.New()
         Me.Value = Value
      End Sub
   End Class 'NotifyEventArgs(Of T)

   Public Module ObjectX

      <DebuggerStepThrough(), Extension()> _
      Public Function Null(Of T As Class)(Subj As T) As Boolean
         Return Subj Is Nothing
      End Function

      <DebuggerStepThrough(), Extension()> _
      Public Function Null(Of T As Structure)(Subj As T?) As Boolean
         Return Not Subj.HasValue
      End Function

      <DebuggerStepThrough(), Extension()> _
      Public Function NotNull(Of T As Class)(Subj As T) As Boolean
         Return Subj IsNot Nothing
      End Function

      <DebuggerStepThrough(), Extension()> _
      Public Function NotNull(Of T As Structure)(Subj As T?) As Boolean
         Return Subj.HasValue
      End Function

      Public Sub DisposeAll(ParamArray Disposables As IDisposable())
         For Each D As IDisposable In Disposables
            If D IsNot Nothing Then D.Dispose()
         Next
      End Sub

   End Module 'ObjectX

End Namespace
